=== modified file 'Makefile'
--- Makefile	2011-10-15 16:48:03 +0000
+++ Makefile	2011-08-17 22:46:35 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code
+#	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.4.1
+version=1.3.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -65,9 +65,7 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@);\
-	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
-	--local-file $(notdir $@) >/dev/null)
+	$(MANPOST) $(notdir $@))
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 

=== modified file 'NEWS'
--- NEWS	2011-10-15 16:48:03 +0000
+++ NEWS	2011-07-27 17:58:27 +0000
@@ -1,26 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.4.1 (2011-10-15)
-* Server
-** Make D-Bus properties settable again, and handle checkers
-   for disabled clients correctly.
-* Miscellaneous fixes to "pedantic" Lintian warnings
-
-Version 1.4.0 (2011-10-09)
-* README file migrated to manual page intro(8mandos).
-* Client:
-** Fixed warning about "rmdir: Directory not empty".
-* Server:
-** Default values changed: timeout 5 minutes, interval 2 minutes.
-** Clients gets an expiration extension when receiving a password,
-   controlled by new "extended_timeout" setting.
-** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
-   also affects the D-Bus bus and interface names (old names still
-   work).  Users should start using the new names immediately.
-** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
-   see DBUS-API for details.
-
 Version 1.3.1 (2011-07-27)
 * Client:
 ** Client now retries all Mandos servers periodically.

=== modified file 'TODO'
--- TODO	2011-11-13 13:55:45 +0000
+++ TODO	2011-09-26 19:36:18 +0000
@@ -7,7 +7,6 @@
 * mandos-applet
 
 * mandos-client
-** TODO [#A] Document network hook functionality
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
@@ -17,7 +16,7 @@
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
-* usplash (Deprecated)
+* usplash
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
@@ -67,7 +66,6 @@
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
-   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
@@ -83,7 +81,6 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
-** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -117,8 +114,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which package moves the other bin/sh when busybox is deactivated
-** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which packet move the other bin/sh when busy box is deactivated
+** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'common.ent'
--- common.ent	2011-10-15 16:48:03 +0000
+++ common.ent	2011-07-27 17:58:27 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.4.1">
+<!ENTITY version "1.3.1">

=== modified file 'debian/changelog'
--- debian/changelog	2011-10-15 16:48:03 +0000
+++ debian/changelog	2011-07-27 17:58:27 +0000
@@ -1,35 +1,3 @@
-mandos (1.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "man".
-  * debian/control (Conflicts): Changed to "Breaks:".
-  * debian/copyright: Updated format.
-  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
-  * debian/mandos-client.postrm: - '' -
-  * debian/mandos.postinst: - '' -
-  * debian/mandos.prerm: Consistent magic.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
-
-mandos (1.4.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
-    LDFLAGS in Makefile. (Closes: #632145)
-  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
-    new PID file locations. (Closes: #643554)
-  * debian/source/local-options: New; contains "--single-debian-patch".
-  * debian/control (Standards-Version): Upgraded to "3.9.2".
-    (DM-Upload-Allowed): New; set to "yes".
-  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
-  * debian/copyright: - '' -
-  * debian/mandos-client.README.Debian: - '' -
-  * debian/mandos.README.Debian: - '' -
-  * debian/watch: - '' -
-  * debian/control (mandos/Description): Fix language to placate lintian.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
-
 mandos (1.3.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-10-11 19:36:00 +0000
+++ debian/control	2011-10-05 16:00:56 +0000
@@ -6,12 +6,11 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man
-Standards-Version: 3.9.2
+	pkg-config
+Standards-Version: 3.9.1
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
-DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
@@ -38,7 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Breaks: dropbear (<= 0.53.1-1)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2011-10-10 20:29:58 +0000
+++ debian/copyright	2011-10-05 16:00:56 +0000
@@ -1,7 +1,8 @@
-Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
+Format-Specification:
+ http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
 Upstream-Name: Mandos
-Upstream-Contact: Mandos <mandos@recompile.se>
-Source: <http://www.recompile.se/mandos>
+Upstream-Maintainer: Mandos Maintainers <mandos@recompile.se>
+Upstream-Source: <http://www.recompile.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2011 Teddy Hogeborn

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,7 +26,6 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
-set -e
 
 # Update the initial RAM file system image
 update_initramfs()

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos.postinst	2009-05-24 23:28:04 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 case "$1" in
     configure)
 	# Rename old "mandos" user and group

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2011-10-10 20:29:58 +0000
+++ debian/mandos.prerm	2009-01-18 00:16:57 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#! /bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== removed file 'debian/source/local-options'
--- debian/source/local-options	2011-10-08 21:13:46 +0000
+++ debian/source/local-options	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
---single-debian-patch

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-11-13 20:49:21 +0000
+++ initramfs-tools-hook	2010-09-09 18:16:14 +0000
@@ -68,7 +68,6 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
@@ -107,24 +106,6 @@
     esac
 done
 
-# Copy network hooks
-for hook in /etc/mandos/network-hooks.d/*; do
-    case "`basename \"$hook\"`" in
-	"*") continue ;;
-	*[!A-Za-z0-9_-]*) continue ;;
-	*) test -d "$hook" || copy_exec "$hook" "${HOOKDIR}" ;;
-    esac
-    # Copy any files needed by the network hook
-    MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
-	"$hook" files | while read file target; do
-	if [ -z "${target}" ]; then
-	    copy_exec "$file"
-	else
-	    copy_exec "$file" "$target"
-	fi
-    done
-done
-
 # GPGME needs /usr/bin/gpg
 if [ ! -e "${DESTDIR}/usr/bin/gpg" \
     -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
@@ -150,7 +131,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files
+# Key files 
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'mandos'
--- mandos	2011-10-15 16:48:03 +0000
+++ mandos	2011-10-05 16:00:56 +0000
@@ -83,7 +83,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.4.1"
+version = "1.3.1"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -160,8 +160,7 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server
-                            .GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
@@ -322,7 +321,7 @@
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)
+        return _timedelta_to_milliseconds(self.extended_timeout)    
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
@@ -362,8 +361,7 @@
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
-        self.extended_timeout = string_to_delta(config
-                                                ["extended_timeout"])
+        self.extended_timeout = string_to_delta(config["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
         self.disable_hook = disable_hook
         self.checker = None
@@ -382,15 +380,13 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = (multiprocessing_manager
-                             .Condition(multiprocessing_manager
-                                        .Lock()))
+        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
     def send_changedstate(self):
         self.changedstate.acquire()
         self.changedstate.notify_all()
         self.changedstate.release()
-    
+        
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
@@ -464,13 +460,11 @@
         if timeout is None:
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
-        if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
-                                           (timeout), self.disable))
-            self.expires = datetime.datetime.utcnow() + timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.expires = datetime.datetime.utcnow() + timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (_timedelta_to_milliseconds(timeout),
+                                       self.disable))
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -635,18 +629,15 @@
         """
         return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, prop in
-                inspect.getmembers(cls, self._is_dbus_property))
+                for name, prop in inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
         for cls in  self.__class__.__mro__:
-            for name, value in (inspect.getmembers
-                                (cls, self._is_dbus_property)):
-                if (value._dbus_name == property_name
-                    and value._dbus_interface == interface_name):
+            for name, value in inspect.getmembers(cls, self._is_dbus_property):
+                if value._dbus_name == property_name and value._dbus_interface == interface_name:
                     return value.__get__(self)
         
         # No such property
@@ -763,8 +754,7 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
-class AlternateDBusNamesMetaclass(DBusObjectWithProperties
-                                  .__metaclass__):
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties.__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
     will add additional D-Bus attributes matching a certain pattern.
     """
@@ -893,27 +883,25 @@
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
 
-        transform_fun: Function that takes a value and a variant_level
-                       and transforms it to a D-Bus type.
+        transform_fun: Function that takes a value and transforms it
+                       to a D-Bus type.
         dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{0}".format(dbus_name)
+        real_value = [None,]
         def setter(self, value):
+            old_value = real_value[0]
+            real_value[0] = value
             if hasattr(self, "dbus_object_path"):
-                if (not hasattr(self, attrname) or
-                    type_func(getattr(self, attrname, None))
-                    != type_func(value)):
-                    dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
+                if type_func(old_value) != type_func(real_value[0]):
+                    dbus_value = transform_func(type_func(real_value[0]),
+                                                variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
-            setattr(self, attrname, value)
         
-        return property(lambda self: getattr(self, attrname), setter)
+        return property(lambda self: real_value[0], setter)
     
     
     expires = notifychangeproperty(datetime_to_dbus, "Expires")
@@ -924,32 +912,24 @@
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
     checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker:
-                                       checker is not None)
+                                   type_func = lambda checker: checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_approval_request = notifychangeproperty(
-        datetime_to_dbus, "LastApprovalRequest")
+    last_approval_request = notifychangeproperty(datetime_to_dbus,
+                                                 "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt16,
-                                          "ApprovalDelay",
-                                          type_func =
-                                          _timedelta_to_milliseconds)
-    approval_duration = notifychangeproperty(
-        dbus.UInt16, "ApprovalDuration",
-        type_func = _timedelta_to_milliseconds)
+    approval_delay = notifychangeproperty(dbus.UInt16, "ApprovalDelay",
+                                          type_func = _timedelta_to_milliseconds)
+    approval_duration = notifychangeproperty(dbus.UInt16, "ApprovalDuration",
+                                             type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
-                                   type_func =
-                                   _timedelta_to_milliseconds)
-    extended_timeout = notifychangeproperty(
-        dbus.UInt16, "ExtendedTimeout",
-        type_func = _timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt16,
-                                    "Interval",
-                                    type_func =
-                                    _timedelta_to_milliseconds)
+                                   type_func = _timedelta_to_milliseconds)
+    extended_timeout = notifychangeproperty(dbus.UInt16, "ExtendedTimeout",
+                                            type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16, "Interval",
+                                    type_func = _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1190,18 +1170,18 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
         else:
             self.expires = (datetime.datetime.utcnow()
-                            + datetime.timedelta(milliseconds =
-                                                 time_to_die))
+                            + datetime.timedelta(milliseconds = time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
@@ -1373,7 +1353,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")
+                            client.Rejected("Disabled")                    
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1396,11 +1376,10 @@
                         return
                     
                     #wait until timeout or approved
+                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    (client.changedstate.wait
-                     (float(client._timedelta_to_milliseconds(delay)
-                            / 1000)))
+                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1430,7 +1409,7 @@
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout using extended_timeout
+                # bump the timeout as if seen
                 client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
@@ -1516,14 +1495,11 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-    
+            
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        proc = multiprocessing.Process(target = self.sub_process_main,
-                                       args = (request,
-                                               address))
-        proc.start()
-        return proc
+        multiprocessing.Process(target = self.sub_process_main,
+                                args = (request, address)).start()
 
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
@@ -1535,12 +1511,12 @@
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
         
-        proc = MultiprocessingMixIn.process_request(self, request,
-                                                    client_address)
+        super(MultiprocessingMixInWithPipe,
+              self).process_request(request, client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe, proc)
+        self.add_pipe(parent_pipe)
     
-    def add_pipe(self, parent_pipe, proc):
+    def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
         raise NotImplementedError
 
@@ -1634,21 +1610,17 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
-    
     def enable(self):
         self.enabled = True
-    
-    def add_pipe(self, parent_pipe, proc):
+    def add_pipe(self, parent_pipe):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe =
-                                               parent_pipe,
-                                               proc = proc))
-    
+                                               parent_pipe = parent_pipe))
+        
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   proc = None, client_object=None):
+                   client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1663,10 +1635,8 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error, or the other end of multiprocessing.Pipe has closed
+        # error or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
-            # Wait for other process to exit
-            proc.join()
             return False
         
         # Read a request from the child
@@ -1686,39 +1656,31 @@
                             "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr,
-                                                       address[0])
+                    mandos_dbus_service.ClientNotFound(fpr, address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe =
-                                                   parent_pipe,
-                                                   proc = proc,
-                                                   client_object =
-                                                   client))
+                                                   parent_pipe = parent_pipe,
+                                                   client_object = client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on
-            # same fileno
+            # remove the old hook in favor of the new above hook on same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object,
-                                              funcname)(*args,
-                                                         **kwargs)))
+            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object
-                                  .__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -2015,9 +1977,8 @@
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
                                             bus, do_not_queue=True)
-            old_bus_name = (dbus.service.BusName
-                            ("se.bsnet.fukt.Mandos", bus,
-                             do_not_queue=True))
+            old_bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
+                                                bus, do_not_queue=True)
         except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
@@ -2036,8 +1997,7 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBusTransitional,
-                                         bus = bus)
+        client_class = functools.partial(ClientDBusTransitional, bus = bus)        
     def client_config_items(config, section):
         special_settings = {
             "approved_by_default":
@@ -2138,7 +2098,6 @@
         "Cleanup function; run on exit"
         service.cleanup()
         
-        multiprocessing.active_children()
         while tcp_server.clients:
             client = tcp_server.clients.pop()
             if use_dbus:
@@ -2148,8 +2107,7 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client
-                                                  .dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
                                                   client.name)
     
     atexit.register(cleanup)

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
+++ mandos-clients.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-10-10">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -190,7 +190,7 @@
 	  </para>
 	  <para>
 	    Extended timeout is an added timeout that is given once
-	    after a password has been sent successfully to a client.
+	    after a password has been sent sucessfully to a client.
 	    The timeout is by default longer than the normal timeout,
 	    and is used for handling the extra long downtime while a
 	    machine is booting up.  Time to take into consideration

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-15 16:48:03 +0000
+++ mandos-ctl	2011-10-05 16:00:56 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2011 Teddy Hogeborn
-# Copyright © 2008-2011 Björn Påhlsson
+# Copyright © 2008-2010 Teddy Hogeborn
+# Copyright © 2008-2010 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.4.1"
+version = "1.3.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -301,41 +301,41 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker is not None:
+            if options.checker:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host is not None:
+            if options.host:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval is not None:
+            if options.interval:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay is not None:
+            if options.approval_delay:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration is not None:
+            if options.approval_duration:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout is not None:
+            if options.timeout:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout is not None:
+            if options.extended_timeout:
                 client.Set(client_interface, "ExtendedTimeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.extended_timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret is not None:
+            if options.secret:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-15 16:48:03 +0000
+++ mandos-keygen	2011-10-05 16:00:56 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.4.1"
+VERSION="1.3.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-15 16:48:03 +0000
+++ mandos-monitor	2011-10-05 16:00:56 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.4.1"
+version = "1.3.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-15 16:48:03 +0000
+++ mandos.lsm	2011-10-05 16:00:56 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.4.1
-Entered-date:	2011-10-15
+Version:	1.3.1
+Entered-date:	2011-07-27
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      138K mandos_1.4.1.orig.tar.gz
+	      136K mandos_1.3.1.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		138K mandos_1.4.1.orig.tar.gz
+		136K mandos_1.3.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-10-09 12:32:13 +0000
+++ plugin-runner.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-10-05 16:56:06 +0000
+++ plugin-runner.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2011-10-05">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -261,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>
+	  </para>	
 	</listitem>
       </varlistentry>
       

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-11-14 20:55:32 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -53,7 +53,7 @@
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open(), S_ISREG */
+#include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
@@ -85,8 +85,6 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -110,8 +108,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			 /* gnutls_certificate_set_openpgp_key_file(),
-			    GNUTLS_OPENPGP_FMT_BASE64 */
+			  /* gnutls_certificate_set_openpgp_key_file(),
+				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -125,7 +123,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
@@ -133,7 +130,6 @@
 const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
-const char *hookdir = HOOKDIR;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -174,22 +170,13 @@
   perror(print_text);
 }
 
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
 size_t incbuffer(char **buffer, size_t buffer_length,
-		 size_t buffer_capacity){
+		  size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
     if(buffer == NULL){
@@ -201,8 +188,9 @@
 }
 
 /* Add server to set of servers to retry periodically */
-int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-	       int af){
+int add_server(const char *ip, uint16_t port,
+		 AvahiIfIndex if_index,
+		 int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
@@ -210,9 +198,9 @@
     return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
-			  .port = port,
-			  .if_index = if_index,
-			  .af = af };
+			 .port = port,
+			 .if_index = if_index,
+			 .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
     return -1;
@@ -240,8 +228,8 @@
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey, const char *pubkey,
-		       const char *tempdir){
+static bool init_gpgme(const char *seckey,
+		       const char *pubkey, const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -262,15 +250,15 @@
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
@@ -283,23 +271,23 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GPGME\n");
+    fprintf(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
   /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_get_engine_info: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   while(engine_info != NULL){
@@ -311,17 +299,15 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf_plus(stderr, "Could not set GPGME home dir to %s\n",
-		 tempdir);
+    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
-		 gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
@@ -346,24 +332,23 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf_plus(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_data_new: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
   }
@@ -372,32 +357,31 @@
      data buffer */
   rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
-	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
+	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf_plus(stderr, "Unsupported algorithm: %s\n",
-		     result->unsupported_algorithm);
-	fprintf_plus(stderr, "Wrong key usage: %u\n",
-		     result->wrong_key_usage);
+	fprintf(stderr, "Unsupported algorithm: %s\n",
+		result->unsupported_algorithm);
+	fprintf(stderr, "Wrong key usage: %u\n",
+		result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf_plus(stderr, "File name: %s\n", result->file_name);
+	  fprintf(stderr, "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf_plus(stderr, "Public key algorithm: %s\n",
-		       gpgme_pubkey_algo_name
-		       (recipient->pubkey_algo));
-	  fprintf_plus(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf_plus(stderr, "Secret key available: %s\n",
-		       recipient->status == GPG_ERR_NO_SECKEY
-		       ? "No" : "Yes");
+	  fprintf(stderr, "Public key algorithm: %s\n",
+		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
+	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
+	  fprintf(stderr, "Secret key available: %s\n",
+		  recipient->status == GPG_ERR_NO_SECKEY
+		  ? "No" : "Yes");
 	  recipient = recipient->next;
 	}
       }
@@ -406,7 +390,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decryption of OpenPGP data succeeded\n");
+    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
@@ -419,12 +403,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				   (size_t)plaintext_length,
-				   plaintext_capacity);
+				      (size_t)plaintext_length,
+				      plaintext_capacity);
     if(plaintext_capacity == 0){
-      perror_plus("incbuffer");
-      plaintext_length = -1;
-      goto decrypt_end;
+	perror_plus("incbuffer");
+	plaintext_length = -1;
+	goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -443,7 +427,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decrypted password is: ");
+    fprintf(stderr, "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -471,7 +455,7 @@
 /* GnuTLS log function callback */
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf_plus(stderr, "GnuTLS: %s", string);
+  fprintf(stderr, "GnuTLS: %s", string);
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
@@ -479,13 +463,13 @@
   int ret;
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GnuTLS\n");
+    fprintf(stderr, "Initializing GnuTLS\n");
   }
   
   ret = gnutls_global_init();
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS global_init: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS global_init: %s\n",
+	    safer_gnutls_strerror(ret));
     return -1;
   }
   
@@ -500,43 +484,41 @@
   /* OpenPGP credentials */
   ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS memory error: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS memory error: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
   }
   
   if(debug){
-    fprintf_plus(stderr, "Attempting to use OpenPGP public key %s and"
-		 " secret key %s as GnuTLS credentials\n",
-		 pubkeyfilename,
-		 seckeyfilename);
+    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
+	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
+	    seckeyfilename);
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
     (mc.cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error[%d] while reading the OpenPGP key pair ('%s',"
-		 " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf_plus(stderr, "The GnuTLS error is: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr,
+	    "Error[%d] while reading the OpenPGP key pair ('%s',"
+	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
+    fprintf(stderr, "The GnuTLS error is: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS DH parameter"
-		 " initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
+	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -562,9 +544,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error in GnuTLS session initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
+	    safer_gnutls_strerror(ret));
   }
   
   {
@@ -577,9 +558,9 @@
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf_plus(stderr, "Syntax error at: %s\n", err);
-      fprintf_plus(stderr, "GnuTLS error: %s\n",
-		   safer_gnutls_strerror(ret));
+      fprintf(stderr, "Syntax error at: %s\n", err);
+      fprintf(stderr, "GnuTLS error: %s\n",
+	      safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -594,8 +575,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error setting GnuTLS credentials: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
   }
@@ -646,7 +627,7 @@
     pf = PF_INET;
     break;
   default:
-    fprintf_plus(stderr, "Bad address family: %d\n", af);
+    fprintf(stderr, "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
@@ -657,8 +638,8 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
-		 PRIu16 "\n", ip, port);
+    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
+	    "\n", ip, port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
@@ -690,7 +671,7 @@
   }
   if(ret == 0){
     int e = errno;
-    fprintf_plus(stderr, "Bad address: %s\n", ip);
+    fprintf(stderr, "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
@@ -701,10 +682,10 @@
     
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-				-Wunreachable-code*/
+			      -Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf_plus(stderr, "An IPv6 link-local address is"
-		     " incomplete without a network interface\n");
+	fprintf(stderr, "An IPv6 link-local address is incomplete"
+		" without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
       }
@@ -728,12 +709,12 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIu16
-		     "\n", ip, interface, port);
+	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
+		ip, interface, port);
       }
     } else {
-      fprintf_plus(stderr, "Connection to: %s, port %" PRIu16 "\n",
-		   ip, port);
+      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
+	      port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -749,7 +730,7 @@
       perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
-	fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+	fprintf(stderr, "Canonical address form: %s\n", addrstr);
       }
     }
   }
@@ -783,7 +764,7 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-					out_size - written));
+				   out_size - written));
     if(ret == -1){
       int e = errno;
       perror_plus("write");
@@ -809,7 +790,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Establishing TLS session with %s\n", ip);
+    fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -835,7 +816,7 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf_plus(stderr, "*** GnuTLS Handshake failed ***\n");
+      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -845,8 +826,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf_plus(stderr, "Retrieving OpenPGP encrypted password from"
-		 " %s\n", ip);
+    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
+	    ip);
   }
   
   while(true){
@@ -857,7 +838,7 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				buffer_capacity);
+				   buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
       perror_plus("incbuffer");
@@ -890,16 +871,15 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf_plus(stderr, "*** GnuTLS Re-handshake failed "
-		       "***\n");
+	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf_plus(stderr, "Unknown error while reading data from"
-		     " encrypted session with Mandos server\n");
+	fprintf(stderr, "Unknown error while reading data from"
+		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
 	goto mandos_end;
@@ -910,7 +890,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Closing TLS session\n");
+    fprintf(stderr, "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -928,7 +908,8 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
+					       buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
@@ -945,8 +926,8 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf_plus(stderr, "Error writing encrypted data: %s\n",
-			 strerror(errno));
+	    fprintf(stderr, "Error writing encrypted data: %s\n",
+		    strerror(errno));
 	  }
 	  errno = e;
 	  goto mandos_end;
@@ -1009,10 +990,9 @@
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
-		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
-		 domain,
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
+	    " of type '%s' in domain '%s': %s\n", name, type, domain,
+	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -1020,9 +1000,9 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf_plus(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		     PRIdMAX ") on port %" PRIu16 "\n", name,
-		     host_name, ip, (intmax_t)interface, port);
+	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
+		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
+		ip, (intmax_t)interface, port);
       }
       int ret = start_mandos_communication(ip, port, interface,
 					   avahi_proto_to_af(proto));
@@ -1060,8 +1040,8 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf_plus(stderr, "(Avahi browser) %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi browser) %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     avahi_simple_poll_quit(mc.simple_poll);
     return;
     
@@ -1074,9 +1054,8 @@
     if(avahi_s_service_resolver_new(mc.server, interface, protocol,
 				    name, type, domain, protocol, 0,
 				    resolve_callback, NULL) == NULL)
-      fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
-		   " %s\n", name,
-		   avahi_strerror(avahi_server_errno(mc.server)));
+      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
+	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1085,8 +1064,7 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf_plus(stderr, "No Mandos server found, still"
-		   " searching...\n");
+      fprintf(stderr, "No Mandos server found, still searching...\n");
     }
     break;
   }
@@ -1107,131 +1085,107 @@
   errno = old_errno;
 }
 
-bool get_flags(const char *ifname, struct ifreq *ifr){
-  int ret;
-  
-  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(s < 0){
-    perror_plus("socket");
-    return false;
-  }
-  strcpy(ifr->ifr_name, ifname);
-  ret = ioctl(s, SIOCGIFFLAGS, ifr);
-  if(ret == -1){
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  ssize_t ssret;
+  char *flagname = NULL;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
+		     if_entry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
+  if(flags_fd == -1){
+    perror_plus("open");
+    free(flagname);
+    return 0;
+  }
+  free(flagname);
+  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
+  /* read line from flags_fd */
+  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
+  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
+  flagstring[(size_t)to_read] = '\0';
+  if(flagstring == NULL){
+    perror_plus("malloc");
+    close(flags_fd);
+    return 0;
+  }
+  while(to_read > 0){
+    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
+					     (size_t)to_read));
+    if(ssret == -1){
+      perror_plus("read");
+      free(flagstring);
+      close(flags_fd);
+      return 0;
+    }
+    to_read -= ssret;
+    if(ssret == 0){
+      break;
+    }
+  }
+  close(flags_fd);
+  intmax_t tmpmax;
+  char *tmp;
+  errno = 0;
+  tmpmax = strtoimax(flagstring, &tmp, 0);
+  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
+					 and not (isspace(*tmp)))
+     or tmpmax != (ifreq_flags)tmpmax){
     if(debug){
-      perror_plus("ioctl SIOCGIFFLAGS");
+      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
+	      flagstring, if_entry->d_name);
     }
-    return false;
+    free(flagstring);
+    return 0;
   }
-  return true;
-}
-
-bool good_flags(const char *ifname, const struct ifreq *ifr){
-  
+  free(flagstring);
+  ifreq_flags flags = (ifreq_flags)tmpmax;
   /* Reject the loopback device */
-  if(ifr->ifr_flags & IFF_LOOPBACK){
+  if(flags & IFF_LOOPBACK){
     if(debug){
-      fprintf_plus(stderr, "Rejecting loopback interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
     if(debug){
-      fprintf_plus(stderr, "Accepting point-to-point interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return true;
+    return 1;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+  if(not (flags & IFF_BROADCAST)){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-broadcast interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(ifr->ifr_flags & IFF_NOARP){
+  if(flags & IFF_NOARP){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-ARP interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
-  
   /* Accept this device */
   if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is good\n", ifname);
-  }
-  return true;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  return 1;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device which is up.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int up_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject down interfaces */
-  if(not (ifr.ifr_flags & IFF_UP)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting down interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject non-running interfaces */
-  if(not (ifr.ifr_flags & IFF_RUNNING)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting non-running interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
+    fprintf(stderr, "Interface \"%s\" is acceptable\n",
+	    if_entry->d_name);
   }
   return 1;
 }
@@ -1247,63 +1201,6 @@
   return 1;
 }
 
-/* Is this directory entry a runnable program? */
-int runnable_hook(const struct dirent *direntry){
-  int ret;
-  size_t sret;
-  struct stat st;
-  
-  if((direntry->d_name)[0] == '\0'){
-    /* Empty name? */
-    return 0;
-  }
-  
-  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
-		"abcdefghijklmnopqrstuvwxyz"
-		"0123456789"
-		"_-");
-  if((direntry->d_name)[sret] != '\0'){
-    /* Contains non-allowed characters */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" with bad name\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  
-  char *fullname = NULL;
-  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-  if(ret < 0){
-    perror_plus("asprintf");
-    return 0;
-  }
-  
-  ret = stat(fullname, &st);
-  if(ret == -1){
-    if(debug){
-      perror_plus("Could not stat hook");
-    }
-    return 0;
-  }
-  if(not (S_ISREG(st.st_mode))){
-    /* Not a regular file */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not a file\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
-    /* Not executable */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not executable\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  return 1;
-}
-
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
@@ -1313,14 +1210,14 @@
   while(true){
     if(mc.current_server == NULL){
       if (debug){
-	fprintf_plus(stderr, "Wait until first server is found."
-		     " No timeout!\n");
+	fprintf(stderr,
+		"Wait until first server is found. No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
       if (debug){
-	fprintf_plus(stderr, "Check current_server if we should run"
-		     " it, or wait\n");
+	fprintf(stderr, "Check current_server if we should run it,"
+		" or wait\n");
       }
       /* the current time */
       ret = clock_gettime(CLOCK_MONOTONIC, &now);
@@ -1342,8 +1239,7 @@
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
       if (debug){
-	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
-		     block_time);
+	fprintf(stderr, "Blocking for %" PRIdMAX " ms\n", block_time);
       }
       
       if(block_time <= 0){
@@ -1369,111 +1265,13 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if (ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR) {
 	return (ret != 1) ? ret : 0;
       }
     }
   }
 }
 
-bool run_network_hooks(const char *mode, const char *interface,
-		       const float delay){
-  struct dirent **direntries;
-  struct dirent *direntry;
-  int ret;
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-  if(numhooks == -1){
-    perror_plus("scandir");
-  } else {
-    int devnull = open("/dev/null", O_RDONLY);
-    for(int i = 0; i < numhooks; i++){
-      direntry = direntries[0];
-      char *fullname = NULL;
-      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-      if(ret < 0){
-	perror_plus("asprintf");
-	continue;
-      }
-      pid_t hook_pid = fork();
-      if(hook_pid == 0){
-	/* Child */
-	dup2(devnull, STDIN_FILENO);
-	close(devnull);
-	dup2(STDERR_FILENO, STDOUT_FILENO);
-	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("DEVICE", interface, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("MODE", mode, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	char *delaystring;
-	ret = asprintf(&delaystring, "%f", delay);
-	if(ret == -1){
-	  perror_plus("asprintf");
-	  return false;
-	}
-	ret = setenv("DELAY", delaystring, 1);
-	if(ret == -1){
-	  free(delaystring);
-	  perror_plus("setenv");
-	  return false;
-	}
-	free(delaystring);
-	ret = execl(fullname, direntry->d_name, mode, NULL);
-	perror_plus("execl");
-      } else {
-	int status;
-	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	  perror_plus("waitpid");
-	  free(fullname);
-	  continue;
-	}
-	if(WIFEXITED(status)){
-	  if(WEXITSTATUS(status) != 0){
-	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-			 " with status %d\n", direntry->d_name,
-			 WEXITSTATUS(status));
-	    free(fullname);
-	    continue;
-	  }
-	} else if(WIFSIGNALED(status)){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		       " signal %d\n", direntry->d_name,
-		       WTERMSIG(status));
-	  free(fullname);
-	  continue;
-	} else {
-	  fprintf_plus(stderr, "Warning: network hook \"%s\""
-		       " crashed\n", direntry->d_name);
-	  free(fullname);
-	  continue;
-	}
-      }
-      free(fullname);
-      if(quit_now){
-	break;
-      }
-    }
-    close(devnull);
-  }
-  return true;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1561,10 +1359,6 @@
 	.arg = "SECONDS",
 	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
-      { .name = "network-hook-dir", .key = 133,
-	.arg = "DIR",
-	.doc = "Directory where network hooks are located",
-	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1623,9 +1417,6 @@
 	  argp_error(state, "Bad retry interval");
 	}
 	break;
-      case 133:			/* --network-hook-dir */
-	hookdir = arg;
-	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
 	 */
@@ -1637,9 +1428,7 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
-	fprintf_plus(state->out_stream,
-		     "Mandos plugin mandos-client: ");
-	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
+	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
       default:
@@ -1690,8 +1479,7 @@
 	if(ret == -1){
 	  perror_plus("fstat");
 	} else {
-	  if(S_ISREG(st.st_mode)
-	     and st.st_uid == 0 and st.st_gid == 0){
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
 	    ret = fchown(seckey_fd, uid, gid);
 	    if(ret == -1){
 	      perror_plus("fchown");
@@ -1711,8 +1499,7 @@
 	if(ret == -1){
 	  perror_plus("fstat");
 	} else {
-	  if(S_ISREG(st.st_mode)
-	     and st.st_uid == 0 and st.st_gid == 0){
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
 	    ret = fchown(pubkey_fd, uid, gid);
 	    if(ret == -1){
 	      perror_plus("fchown");
@@ -1731,45 +1518,19 @@
     }
   }
   
-  /* Run network hooks */
-  {
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
-    if(ret == -1){
-      perror_plus("seteuid");
-    }
-    if(not run_network_hooks("start", interface, delay)){
-      goto end;
-    }
-    /* Lower privileges */
-    errno = 0;
-    ret = seteuid(uid);
-    if(ret == -1){
-      perror_plus("seteuid");
-    }
-  }
-  
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-  
+
   if(interface[0] == '\0'){
     struct dirent **direntries;
-    /* First look for interfaces that are up */
-    ret = scandir(sys_class_net, &direntries, up_interface,
+    ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
-    if(ret == 0){
-      /* No up interfaces, look for any good interfaces */
-      free(direntries);
-      ret = scandir(sys_class_net, &direntries, good_interface,
-		    alphasort);
-    }
     if(ret >= 1){
-      /* Pick the first interface returned */
+      /* Pick the first good interface */
       interface = strdup(direntries[0]->d_name);
       if(debug){
-	fprintf_plus(stderr, "Using interface \"%s\"\n", interface);
+	fprintf(stderr, "Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
 	perror_plus("malloc");
@@ -1780,7 +1541,7 @@
       free(direntries);
     } else {
       free(direntries);
-      fprintf_plus(stderr, "Could not find a network interface\n");
+      fprintf(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
     }
@@ -1792,8 +1553,7 @@
   srand((unsigned int) time(NULL));
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
-    fprintf_plus(stderr,
-		 "Avahi: Failed to create simple poll object.\n");
+    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1865,7 +1625,7 @@
   if(strcmp(interface, "none") != 0){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
-      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      fprintf(stderr, "No such interface: \"%s\"\n", interface);
       exitcode = EX_UNAVAILABLE;
       goto end;
     }
@@ -1991,10 +1751,18 @@
 #endif	/* __linux__ */
     /* Lower privileges */
     errno = 0;
-    /* Lower privileges */
-    ret = seteuid(uid);
-    if(ret == -1){
-      perror_plus("seteuid");
+    if(take_down_interface){
+      /* Lower privileges */
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+    } else {
+      /* Lower privileges permanently */
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
   
@@ -2004,7 +1772,7 @@
   
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
-    fprintf_plus(stderr, "init_gnutls_global failed\n");
+    fprintf(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2026,7 +1794,7 @@
   }
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf_plus(stderr, "init_gpgme failed\n");
+    fprintf(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2042,7 +1810,7 @@
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
-      fprintf_plus(stderr, "No colon in address\n");
+      fprintf(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2056,7 +1824,7 @@
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
-      fprintf_plus(stderr, "Bad port number\n");
+      fprintf(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2092,8 +1860,8 @@
 	break;
       }
       if(debug){
-	fprintf_plus(stderr, "Retrying in %d seconds\n",
-		     (int)retry_interval);
+	fprintf(stderr, "Retrying in %d seconds\n",
+		(int)retry_interval);
       }
       sleep((int)retry_interval);
     }
@@ -2101,7 +1869,7 @@
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-    
+
     goto end;
   }
   
@@ -2129,8 +1897,8 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
-		 avahi_strerror(error));
+    fprintf(stderr, "Failed to create Avahi server: %s\n",
+	    avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2144,8 +1912,8 @@
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
 				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
-    fprintf_plus(stderr, "Failed to create service browser: %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "Failed to create service browser: %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2157,20 +1925,20 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf_plus(stderr, "Starting Avahi loop search\n");
+    fprintf(stderr, "Starting Avahi loop search\n");
   }
 
   ret = avahi_loop_with_timeout(mc.simple_poll,
 				(int)(retry_interval * 1000));
   if(debug){
-    fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
-		 (ret == 0) ? "successfully" : "with error");
+    fprintf(stderr, "avahi_loop_with_timeout exited %s\n",
+	    (ret == 0) ? "successfully" : "with error");
   }
   
  end:
   
   if(debug){
-    fprintf_plus(stderr, "%s exiting\n", argv[0]);
+    fprintf(stderr, "%s exiting\n", argv[0]);
   }
   
   /* Cleanup things */
@@ -2204,24 +1972,19 @@
     }
   }
   
-  /* Re-raise priviliges */
-  {
+  /* Take down the network interface */
+  if(take_down_interface){
+    /* Re-raise priviliges */
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
       perror_plus("seteuid");
     }
-    /* Run network hooks */
-    if(not run_network_hooks("stop", interface, delay)){
-      goto end;
-    }
-    
-    /* Take down the network interface */
-    if(take_down_interface and geteuid() == 0){
+    if(geteuid() == 0){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror_plus("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP){
+      } else if(network.ifr_flags & IFF_UP) {
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
@@ -2232,14 +1995,14 @@
       if(ret == -1){
 	perror_plus("close");
       }
+      /* Lower privileges permanently */
+      errno = 0;
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
-  /* Lower privileges permanently */
-  errno = 0;
-  ret = setuid(uid);
-  if(ret == -1){
-    perror_plus("setuid");
-  }
   
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){
@@ -2259,8 +2022,8 @@
 	}
 	ret = remove(fullname);
 	if(ret == -1){
-	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
-		       strerror(errno));
+	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
+		  strerror(errno));
 	}
 	free(fullname);
       }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-11-13 20:49:21 +0000
+++ plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
@@ -102,10 +102,6 @@
       </arg>
       <sbr/>
       <arg>
-	<option>--network-hook-dir<replaceable>DIR</replaceable></option>
-      </arg>
-      <sbr/>
-      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -315,18 +311,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-
-      <varlistentry>
-	<term><option>--network-hook-dir=<replaceable
-	>DIR</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Network hook directory.  The default directory is
-	    <quote><filename class="directory"
-	    >/lib/mandos/network-hooks.d</filename></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
+++ plugins.d/password-prompt.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

